/*
Keypad Backlight By NeO_2kX.
    EEPROM Api By NeO_2kX!
   !
*/

.binid X100XEDG1
.include "ExtendedApi.h"
.include "KeyPad.h"

@ExtendedApi Handlers
.org __my0_5task_Table+0x64*4
	DCD		my0_5task_0064+1
.org __my0_4if_Table+0x64*4
	DCD		my0_5if_0064+1
.org ExtTextHandler_Table+0x64*4
	DCD		my_0_5get_text_0064+1

@     	
.start 0x000B622C
BL		My_Extended_DateTimeInputTitle
NOP	
	
@    (  )
.start 0x000ACD82
BL 		GetDefaultMenuValue_4_2_3_Sub
B 		0x000ACEA2

@   
.start 0x00128A40
BL 		lk_CheckKeypadLightEnable
B  		exit_hen7_80SwitchOnMainlight
@ 
.byte	"KP1"

@   " "
.start 0x007EDA98
.mcc MCC_MENU 		0xA 0x43D 	0x5 0x34
.mcc MCC_ENAVIGSA 	0xA 0x5 	0 	0 	mcc_set_backlight_15sec 	0x43D
.mcc MCC_ENAVIGA 	0xA 0x5 	0x1 0 	mcc_set_backlight_30sec 	0x43E
.mcc MCC_ENAVIGA 	0xA 0x5 	0x2 0 	mcc_set_backlight_1min 		0x43F
.mcc MCC_ENAVIGA 	0xA 0x5 	0x3 0 	mcc_set_backlight_3min 		0x440
.mcc MCC_ENAVIGEA 	0xA 0x5 	0x4 0 	mcc_set_backlight_10min 	0x441

.start mcc_set_backlight
.mcc MCC_TRANSF 0 0 0 0 mcc_backlight_menu

@  
.start KeyPad_Start
.string "<Keypad Backlight By NeO_2kX>"

.align 1
@void lk_CheckKeypadLightEnable(void);
lk_CheckKeypadLightEnable:
.equ lk_CheckKeypadLightEnable_StackSize #8
PUSH 	{R0-R4, LR}
SUB 	SP, SP, #lk_CheckKeypadLightEnable_StackSize

@   
	BL		Get_Cur_Backlight_Mode

@  ?	
	CMP		R0, #1
	BEQ		lk_CheckKeypadLightEnable_Manual_Time_Read
	
@    ?	
	CMP 	R0, #2
	BEQ		lk_KeypadLightEnable

@  ?	
	CMP		R0, #3
	BEQ		lk_KeypadLightDisable

@ 
	ADD 	R0, SP, #0
	BL 		RtcGetTime		 				@(char* buf):{sec,min,hour, 0,0}

@ 
	ADD		R0, SP, #0
	LDRB 	R0, [R0, #2]

@ 9
	CMP 	R0, #9
	BLT		lk_KeypadLightEnable

@ 17
	CMP 	R0, #17
	BLT 	lk_KeypadLightDisable

lk_KeypadLightEnable:
	BL 		Hard_KeypadBacklightOn
	B		exit_lk_CheckKeypadLightEnable

lk_KeypadLightDisable:
	BL 		Hard_KeypadBacklightOff

exit_lk_CheckKeypadLightEnable:
ADD 	SP, SP, #lk_CheckKeypadLightEnable_StackSize
POP 	{R0-R4, PC}


lk_CheckKeypadLightEnable_Manual_Time_Read:
	ADD 	R0, SP, #0
	BL 		RtcGetTime		 				@(char* buf):{sec,min,hour, 0,0}
	
	ADD		R0, SP, #0
	LDRB	R3, [R0, #2]					@R3 ==  
	LDRB	R4, [R0, #1]					@R4 ==  
	MOV		R0, #60
	MUL		R3, R0							@R3 ==  c  
	ADD		R3, R3, R4						@R3 ==    
	
	MOV		R0, #0
	BL		Get_Save_Time
	LDRB	R1, [R0, #2]					@R1 ==  
	LDRB	R4, [R0, #1]					@R4 ==  
	MOV		R0, #60
	MUL		R1,	R0							@R1 ==    
	ADD		R1, R1, R4						@R1 ==    
		
	MOV 	R0, #1
	BL		Get_Save_Time
	LDRB	R2, [R0, #2]					@R2 ==  
	LDRB	R4, [R0, #1]					@R4 ==  
	MOV		R0, #60
	MUL		R2,	R0							@R2 ==    
	ADD		R2, R2, R4						@R2 ==    
		
	CMP		R1, R2							
	BGT		lk_Manual_Time_Read_Big_Period
	BEQ		lk_Manual_Time_Read_equal_Period

@   < 		
	CMP		R3, R1 							
	BLT		lk_KeypadLightDisable
	
	CMP		R3, R2							
	BLT		lk_KeypadLightEnable
		
	B		lk_KeypadLightDisable

@   > 
lk_Manual_Time_Read_Big_Period:
	CMP		R3, R2							
	BLT		lk_KeypadLightEnable
	
	CMP		R3, R1							
	BLT		lk_KeypadLightDisable
	
	B		lk_KeypadLightEnable

@   == 	=> 	  
lk_Manual_Time_Read_equal_Period:
	B		lk_KeypadLightDisable

@  
@void Hard_KeypadBacklightOff(void);
Hard_KeypadBacklightOff:
PUSH	{R0-R1, R3, LR}
	LDR		R0, =0xFFFF8400
	LDRH	R1, [R0, #10]
	MOV		R3, #0xFF
	ADD		R3, #0x1
	BIC		R1, R3
	STRH	R1, [R0, #10]
POP		{R0-R1, R3, PC}
.data

@  
@void Hard_KeypadBacklightOn(void);
Hard_KeypadBacklightOn:
PUSH	{R0-R1, R3, LR}
	LDR		R0, =0xFFFF8400
	LDRH	R1, [R0, #10]
	MOV		R3, #0xFF
	ADD		R3, #0x1
	ORR		R1, R3
	STRH	R1, [R0, #10]
POP		{R0-R1, R3, PC}
.data

My_Extended_DateTimeInputTitle:
PUSH	{LR}
	CMP 	R0, #7
	BGT		My_Extended_DateTimeInputTitle_exit
	
	CMP		R0, #7
	BEQ		My_Extended_DateTimeInputTitle_Up_To_Get
	
	LDR		R0, =0x2647						@
	B		My_Extended_DateTimeInputTitle_Get
	
My_Extended_DateTimeInputTitle_Up_To_Get:
	LDR		R0, =0x2648						@
	
My_Extended_DateTimeInputTitle_Get:
	BL		lk_get_text
	MOV		R7, R0

My_Extended_DateTimeInputTitle_exit:
	MOV	R0, #0x18
	BL	lk_get_sofk
POP		{PC}
.data

.string "<my0_5task_0064>"
.align 1
my0_5task_0064:
PUSH 	{R1-R7, LR}
	MOV		R7, R0
	LDRH	R0, [R0, #4]
.case R0, exit_my0_5task_0064, Call_KeypadBacklight_Menu_Func Call_KeypadBacklight_Mode_Menu_Func Call_KeypadBacklight_Mode_Menu_Save_Func Call_KeypadBacklight_Mode_Menu_Set Call_KeypadBacklight_Time_Init Call_KeypadBacklight_Time_Save

exit_my0_5task_0064:
POP 	{R1-R7, PC}

Call_KeypadBacklight_Menu_Func:
	BL 		KeypadBacklight_Menu_Func
	B		exit_my0_5task_0064

Call_KeypadBacklight_Mode_Menu_Func:
	BL 		KeypadBacklight_Mode_Menu_Func
	B		exit_my0_5task_0064
	
Call_KeypadBacklight_Mode_Menu_Save_Func:
	BL		KeypadBacklight_Mode_Menu_Save_Func
	B		exit_my0_5task_0064
	
Call_KeypadBacklight_Mode_Menu_Set:
	BL		KeypadBacklight_Mode_Menu_Set
	B		exit_my0_5task_0064	
	
Call_KeypadBacklight_Time_Init:
	BL		KeypadBacklight_Time_Init
	B		exit_my0_5task_0064
	
Call_KeypadBacklight_Time_Save:
	BL		KeypadBacklight_Time_Save
	B		exit_my0_5task_0064

@   " "
KeypadBacklight_Menu_Func:
.equ KeypadBacklight_Stack_Size	#16
PUSH 	{R1-R4, LR}
SUB 	SP, SP, #KeypadBacklight_Stack_Size

@ 
	LDR 	R0, =0x2641						@ 
	BL		lk_get_text	
	MOV 	R2, #0
	MOV 	R1, #0	
	BL		Reg_Draw_Title					@{Title_Str_Adress, ?(0), ?(0)}

@ -
	MOV		R0, #0x2D						@
	BL		lk_get_sofk						@{SK_RES_ID}:Adress
	MOV		R3, #0x11						@ 
	MOV		R2, #0
	MOV		R1, #0
	STR		R1, [SP, #0]
	STR		R1, [SP, #0x4]
	STR		R1, [SP, #0x8]
	BL		Reg_Draw_Softkey				@{1_sk, IconTimerID_1_Sk, 2_sk, IconTimerID_2_Sk, [SP] - Midle_SK, [SP, #4] - IconTimerID_Midle_Sk, [SP, #8] - ?(0)}

	LDR		R4, =DspList	
	MOV		R3, #0
	MOV 	R2, #3
	MOV		R1, #1
	ADD 	R0, R4, #0
	BL		CreateList 						@{DspList struct, Type, Num_of_items, 0}

@  ""
	LDR 	R0, =0x2642
	BL		lk_get_text
	MOV 	R1, #0
	BL 		My_Add_Func						@{Str, num_item}

@  
	BL		Get_Cur_Backlight_Mode
	MOV		R1, R0
	STR		R1, [SP]

	CMP 	R1, #4
	BLT		KeypadBacklight_Menu_Func_Hint_1
	MOV		R1, #0

KeypadBacklight_Menu_Func_Hint_1:	
	LDR 	R0, =0x2643
	ADD		R0, R0, R1
	BL		lk_get_text
	MOV 	R1, #0
	BL 		My_Add_Hint_Func				@{Hint_Str, num_item}
	
@  ""	
	LDR 	R0, =0x2647
	BL		lk_get_text
	MOV 	R1, #1
	BL 		My_Add_Func						@{Str, num_item}
	
	LDR 	R0, [SP]						@R0 = 

@  ?	
	CMP 	R0, #0
	BEQ		KeypadBacklight_Menu_Func_After_Night

@  ?	
	CMP		R0, #1
	BEQ		KeypadBacklight_Menu_Func_After_Manual
	
	MOV		R1, #0							@Min
	MOV		R0, #0							@Hour
	BL		Make_Time_Format				@*Org_SysTime Make_Time_Format_Str(hour,min)
	MOV		R1, #1
	BL		Make_Time_String				@*TimeBuf Make_Time_String(*Org_SysTime, string_type)
	B		KeypadBacklight_Menu_Func_Add_After_Hint
	
KeypadBacklight_Menu_Func_After_Night:
	MOV		R1, #0							@Min
	MOV		R0, #17							@Hour
	BL		Make_Time_Format				@*Org_SysTime Make_Time_Format_Str(hour,min)
	MOV		R1, #1
	BL		Make_Time_String				@*TimeBuf Make_Time_String(*Org_SysTime, string_type)
	B		KeypadBacklight_Menu_Func_Add_After_Hint
	
KeypadBacklight_Menu_Func_After_Manual:
	MOV		R0, #0
	MOV		R1, #1
	BL		Get_Save_Time_String			@*TimeBuf Get_Save_Time_String(time_id, type)
	
KeypadBacklight_Menu_Func_Add_After_Hint:	
	MOV 	R1, #1
	BL 		My_Add_Hint_Func				@{Hint_Str, num_item}
	
@  ""		
	LDR 	R0, =0x2648
	BL		lk_get_text
	MOV 	R1, #2
	BL 		My_Add_Func						@{Str, num_item}
	
	LDR 	R0, [SP]						@R0 = 
	
@  ?	
	CMP 	R0, #0
	BEQ		KeypadBacklight_Menu_Func_Up_To_Night

@  ?	
	CMP		R0, #1
	BEQ		KeypadBacklight_Menu_Func_Up_To_Manual
	
	MOV		R1, #0							@Min
	MOV		R0, #0							@Hour
	BL		Make_Time_Format				@*Org_SysTime Make_Time_Format_Str(hour,min)
	MOV		R1, #1
	BL		Make_Time_String				@*TimeBuf Make_Time_String(*Org_SysTime, string_type)
	B		KeypadBacklight_Menu_Func_Add_Up_To_Hint
	
KeypadBacklight_Menu_Func_Up_To_Night:
	MOV		R1, #0							@Min
	MOV		R0, #9							@Hour
	BL		Make_Time_Format				@*Org_SysTime Make_Time_Format_Str(hour,min)
	MOV		R1, #1
	BL		Make_Time_String				@*TimeBuf Make_Time_String(*Org_SysTime, string_type)
	B		KeypadBacklight_Menu_Func_Add_Up_To_Hint
	
KeypadBacklight_Menu_Func_Up_To_Manual:
	MOV		R0, #1
	MOV		R1, #1
	BL		Get_Save_Time_String			@*TimeBuf Get_Save_Time_String(time_id, type)

KeypadBacklight_Menu_Func_Add_Up_To_Hint:	
	MOV 	R1, #2
	BL 		My_Add_Hint_Func				@{Hint_Str, num_item}

ADD 	SP, SP, #KeypadBacklight_Stack_Size
POP 	{R1-R4, PC}
.data

@ ""
KeypadBacklight_Mode_Menu_Func:
.equ KeypadBacklight_Mode_Menu_Func_Item_Num #4
PUSH 	{R1-R4,R6-R7, LR}
SUB 	SP, SP, #0xC

@ 
	LDR 	R0, =0x2642
	BL		lk_get_text	
	MOV 	R2, #0
	MOV 	R1, #0	
	BL		Reg_Draw_Title					@{Title_Str_Adress, ?(0), ?(0)}

@ -
	MOV		R0, #0x2D						@
	BL		lk_get_sofk						@{SK_RES_ID}:Adress
	MOV		R3, #0x11						@ 
	MOV		R2, #0
	MOV		R1, #0
	STR		R1, [SP, #0]
	STR		R1, [SP, #0x4]
	STR		R1, [SP, #0x8]
	BL		Reg_Draw_Softkey				@{1_sk, IconTimerID_1_Sk, 2_sk, IconTimerID_2_Sk, [SP] - Midle_SK, [SP, #4] - IconTimerID_Midle_Sk, [SP, #8] - ?(0)}
	
@ ""	
	LDR		R4, =DspList	
	MOV		R3, #0
	MOV 	R2, #KeypadBacklight_Mode_Menu_Func_Item_Num
	MOV		R1, #3							@Type == Radio
	ADD 	R0, R4, #0
	BL		CreateList 						@{DspList struct, Type, Num_of_items, 0}

@	
	MOV		R7, #0
@
	LDR 	R6, =0x2643

KeypadBacklight_Mode_Menu_Loop:	
	ADD		R0, R6, R7
	BL		lk_get_text
	ADD		R1, R7, #0
	BL 		My_Add_Func						@{Str, num_item}

@ 	
	ADD		R7, R7, #1
	
	CMP		R7, #KeypadBacklight_Mode_Menu_Func_Item_Num
	BNE		KeypadBacklight_Mode_Menu_Loop

ADD 	SP, SP, #0xC
POP		{R1-R4,R6-R7, PC}
.data

KeypadBacklight_Mode_Menu_Save_Func:
PUSH 	{R0, LR}
	BL		Get_Selected_Num				@  	
	BL		Save_Cur_Backlight_Mode			@ 
	BL		lk_CheckKeypadLightEnable		@  
POP		{R0, PC}

KeypadBacklight_Mode_Menu_Set:
PUSH 	{R0-R1, LR}
	BL		Get_Cur_Backlight_Mode			@ 
	BL		SetCurList						@  ()
POP 	{R0-R1, PC}

@MCC     
KeypadBacklight_Time_Init:
PUSH 	{R1-R3, LR}
SUB		SP, SP, #8
	BL		lk3_0InitEditBuffer
	
	LDRH	R0, [R7, #6]
	CMP		R0, #1							@3-  mcc == 1 ?
	BEQ		KeypadBacklight_Time_Up_To_Init

	MOV		R0, #0

KeypadBacklight_Time_Init_Start:
	MOV		R1, #0	
	BL		Get_Save_Time_String			@*TimeBuf Get_Save_Time_String(time_id, type)

	BL		lk3_2WriteEditBuffer
ADD		SP, SP, #8
POP		{R1-R3, PC}

KeypadBacklight_Time_Up_To_Init:
@
	MOV		R0, #1
	B		KeypadBacklight_Time_Init_Start
.data

KeypadBacklight_Time_Save:
PUSH	{R1-R7, LR}
SUB		SP, SP, #8
	MOV		R0, #1
	BL		lk3_1SetEditBufferPosition		@ 
	
	BL		lk3_3ReadEditBuffer
	MOV		R4, R0							@R4 ==   
	
	MOV		R1, #0
	STRB	R1, [R0, #2]					@ ":"    atoi
	
	MOV		R0, R4
	BL		atoi							@ 
	MOV		R5, R0							@R5 == int 
	
	ADD		R0, R4, #3
	BL		atoi							@ 
	MOV		R4, R0							@R4 == int 
	
	BL		GetCurTimeFormat
	CMP		R0, #1
	BEQ		KeypadBacklight_Time_Save_12_Convert

KeypadBacklight_Time_Save_Start:	
	ADD		R0, SP, #0
	STRB	R4, [R0, #2]
	STRB	R5, [R0, #3]
	
	LDRH	R0, [R7, #6]					
	CMP		R0, #1							@3-  mcc == 1 ?
	BEQ		KeypadBacklight_Time_Up_To_Save

@
	MOV		R0, #2							@ == 2		

KeypadBacklight_Time_Save_Write:	
	LDR		R2, [SP]
	MOV 	R1, #1							@ 
	BL		Write_EEPROM

@   	
	BL		lk_CheckKeypadLightEnable
	
ADD		SP, SP, #8	
POP		{R1-R7, PC}

KeypadBacklight_Time_Up_To_Save:
@
	MOV		R0, #4							@ == 4
	B		KeypadBacklight_Time_Save_Write
	
KeypadBacklight_Time_Save_12_Convert:
	LDR		R0, =AMPM
	LDRB	R0, [R0]
	CMP		R0, #0							@AM ?
	BEQ		KeypadBacklight_Time_Save_12_Convert_AM
	
	CMP		R5, #12							@12  ?
	BEQ		KeypadBacklight_Time_Save_Start
	
	ADD		R5, #12
	B		KeypadBacklight_Time_Save_Start
	
KeypadBacklight_Time_Save_12_Convert_AM:
	CMP		R5, #12
	BNE		KeypadBacklight_Time_Save_Start
	
	MOV		R5, #0
	B		KeypadBacklight_Time_Save_Start	
.data

Get_Selected_Num:
PUSH 	{LR}
	LDR		R0, =DspList
	LDRH	R0, [R0, #32]
POP		{PC}
.data

@   
@{Str, num_item}
My_Add_Func:			
PUSH 	{R2, LR}
	SUB 	SP, SP, #4
	ADD 	R3, R0, #0
	MOV		R0, #0
	STR		R0, [SP]
	MOV		R2, #2
	ADD 	R0, R4, #0
	BL		AddList							@AddList(Main){DspList struct, Num_of_item(from_0), Type(st 0x2), Lan_Res_Addr., [sp]=0}
	ADD 	SP, SP, #4		
POP	 {R2, PC}

@     
@{Hint_Str, num_item}	
My_Add_Hint_Func:
PUSH 	{R2, LR}
	SUB 	SP, SP, #4	
	ADD 	R3, R0, #0
	MOV		R0, #0
	STR		R0, [SP]
	MOV		R2, #3
	ADD 	R0, R4, #0
	BL		AddList							@AddList(Hints){DspList struct, Num_of_item(from_0), Type(0x3), Hint_Lan_Res_Addr., [sp]=0}
	ADD 	SP, SP, #4		
POP 	{R2, PC}

@   (  )
GetDefaultMenuValue_4_2_3_Sub:
PUSH {LR}
	CMP 	R1, #1							@  ?
	BEQ 	Display_BackLight_Value
	
	CMP 	R1, #2							@  ?
	BEQ 	KeyPad_BackLight_Value
	
Display_BackLight_Value:
	LDR		R0, =0x00000F06
	BL		hfd2_30ReadBlockNameInRamImage
	LDR 	R0, [R0]
	LDR		R3, =0x0000043D
	LSL		R0, R0, #8
	LSR		R0, R0, #29
	ADD		R0, R0, R3
	BL		lk_get_text
	B		GetDefaultMenuValue_4_2_3_Sub_Format_Exit	

KeyPad_BackLight_Value:
	ADR		R0, ="By NeO_2kX"

GetDefaultMenuValue_4_2_3_Sub_Format_Exit:	
	MOV		R2, R0
	MOV		R0, R7
	ADR		R1, ="%s"
	BL		_sprintf

POP {PC}
.data

@   
@mode = int Get_Cur_Backlight_Mode(void);
Get_Cur_Backlight_Mode:
PUSH 	{R1, LR}
	MOV		R1, #0
	MOV		R0, #0
	BL		Read_EEPROM
POP 	{R1, PC}

@   
@void Save_Cur_Backlight_Mode(int mode);
Save_Cur_Backlight_Mode:
PUSH	{R0-R1, LR}
	MOV		R2, R0
	MOV		R1, #0
	MOV		R0, #0
	BL		Write_EEPROM
POP		{R0-R1, PC}
.data

@   
@*TimeBuf Get_Save_Time_String(time_id, type)
@id == 0, if after
@id == 1, if up to
Get_Save_Time_String:
PUSH 	{R1, LR}
	CMP		R0, #1
	BEQ		Get_Save_Time_Up_To_String

@	
	MOV		R0, #0
	
Get_Save_Time_String_Start:	
	BL		Get_Save_Time					@*Org_SysTime Get_Save_Time(time_id)

Get_Save_Time_String_Start_2:
	BL		Make_Time_String				@*TimeBuf Make_Time_String(*Org_SysTime, string_type)
POP		{R1, PC}

Get_Save_Time_Up_To_String:
@
	MOV 	R0, #1
	B		Get_Save_Time_String_Start
.data

@  
@*Org_SysTime Get_Save_Time(time_id)
@id == 0, if after
@id == 1, if up to
Get_Save_Time:
PUSH	{R1, LR}
SUB		SP, SP, #4
	CMP		R0, #1
	BEQ		Get_Save_Time_Up_To

@	
	MOV		R0, #2
	
Get_Save_Time_Start:
	MOV		R1, #1
	BL		Read_EEPROM
	
	STR		R0, [SP]	
	ADD		R0, SP, #0
	
	LDRB	R1, [R0, #2]					@Min
	LDRB 	R0, [R0, #3]					@Hour	
	BL		Make_Time_Format				@*Org_SysTime Make_Time_Format_Str(hour,min)
	
ADD		SP, SP, #4
POP		{R1, PC}

Get_Save_Time_Up_To:
@
	MOV		R0, #4
	B 		Get_Save_Time_Start
.data

@    24-  
@*Org_SysTime Make_Time_Format_Str(hour,min)
Make_Time_Format:
PUSH 	{R2, LR}
	LDR		R2, =Org_SysTime
	STRB	R0, [R2, #2]					@Hour
	STRB	R1, [R2, #1]					@Min
	
	MOV		R0, #0							@
	STRB	R0, [R2, #3]					@TimeFormat == 24
	STRB	R0, [R2, #4]					@
	STRB	R0, [R2]						@Sec == 0
	MOV		R0, R2	
POP		{R2, PC}
.data

@*TimeBuf Make_Time_String(*Org_SysTime, string_type)
Make_Time_String:
PUSH {R1-R6, LR}
	MOV		R6, R1
	MOV		R5, R0
	LDR		R4, =TimeBuf	
	BL		GetCurTimeFormat
	CMP 	R0, #0
	BEQ		Make_Time_String_Start

	MOV		R0, R5
	MOV		R1, #1
	BL		lk_ChangeTimeFormat
	
Make_Time_String_Start:
	MOV		R0, R4		
	MOV		R1, R0
	MOV		R2, #0
	MOV		R3, #0
	STMIA	R1!, {R2, R3}
	
	CMP		R6, #1
	BEQ		Make_Time_String_AM_PM
	
Make_Time_String_Start_2:	
	MOV		R1, R5
	BL		lk_GetTimeString
	
	MOV		R0, R4
POP {R1-R6, PC}

Make_Time_String_AM_PM:
	MOV		R2, #2
	B		Make_Time_String_Start_2
.data

GetCurTimeFormat:
@TimeFormat = int GetCurTimeFormat(void)
@TimeFormat:
@0 - 24
@1 - 12
PUSH 	{LR}
	LDR 	R0, =TimeFormat
	LDRB 	R0, [R0]
POP 	{PC}
.data

.string "</my0_5task_0064>"
.string "<my0_5if_0064>"
.align 1
my0_5if_0064:
PUSH 	{R1, LR}
	BL		Get_Cur_Backlight_Mode
	
	CMP		R0, #1
	BEQ		my0_5if_0064_exit_0
	
	MOV 	R0, #1
	B		my0_5if_0064_exit
	
my0_5if_0064_exit_0:
	MOV		R0, #0
	
my0_5if_0064_exit:
POP 	{R1, PC}
.string "</my0_5if_0064>"


@  
.align 1
my_0_5get_text_0064:
	ADD 	R2, R1, #0
	LDR		R3, =0x2640						@R3 =  
	CMP		R0, R3
	BLT		Get_Text_Fast_Menu_3_Exit_Error
	SUB 	R1, R0, R3
	LSL 	R1, R1, #2
	
	CMP 	R2, #3							@  ==  ?
	BNE 	English_Lan
	
	ADR 	R0, =string_table_rus

restore_my_0_5get_text_0064:
	LDR 	R0, [R0, R1]
	BX		LR

English_Lan:
	ADR 	R0, =string_table_eng
	B		restore_my_0_5get_text_0064

Get_Text_Fast_Menu_3_Exit_Error:
	ADR		R0, ="KeyPad_Backlight_error"
	BX		LR
.data


@    (  AlexeyK)
.align 2
string_table_rus:
.word Display_BackLight KeyPad_BackLight Mode_Rus Night_Rus Manual_Rus Always_Rus Disable_Rus After_Rus Up_To_Rus Only_Manual_Mode_Rus

Display_BackLight:
.string " "

KeyPad_BackLight:
.string " "

Mode_Rus:
.string ""

Night_Rus:
.string ".   "

Manual_Rus:
.string ".   "

Always_Rus:
.string ".   "

Disable_Rus:
.string " "

After_Rus:
.string ""

Up_To_Rus:
.string ""

Only_Manual_Mode_Rus:
.string "   . "

string_table_eng:
.word Display_BackLight_Eng KeyPad_BackLight_Eng Mode_Eng Night_Eng Manual_Eng Always_Eng Disable_Eng After_Eng Up_To_Eng Only_Manual_Mode_Eng

Display_BackLight_Eng:
.string "Display backlight"

KeyPad_BackLight_Eng:
.string "Keypad backlight"

Mode_Eng:
.string "Mode"

Night_Eng:
.string "Use at nighttime"
 
Manual_Eng:
.string "Use at custom time" 

Always_Eng:
.string "Use at anytime" 

Disable_Eng:
.string "Not use"
 
After_Eng:
.string "After" 

Up_To_Eng:
.string "Up to"

Only_Manual_Mode_Eng:
.string "Only in a mode of custom time"

@MCC  
.string "<Mcc scripts>"
.align 2
mcc_backlight_menu:
.mcc MCC_INIT_RESTORE
.mcc MCC_TITLE 		0xA 0x424 	0x4
@244
.mcc MCC_MENU 		0xA 0x2640 	0x2 	0x43
.mcc MCC_NAVIGSA 	0xA 0 		0 		0x424 mcc_set_backlight_new		 	0x2640
.mcc MCC_NAVIGEA 	0xA 0 		0 		0x424 My_KeyPad_Backlight_menu		0x2641
.mcc MCC_ELSEIF 	0x9 0x1 	0x9 		0 mcc_set_end
.mcc MCC_RETMENU 	0x1

mcc_set_backlight_new:
.mcc MCC_INIT_RESTORE
.mcc MCC_TRANSF 0 0 0 0 mcc_set_backlight+16

@ ' '
My_KeyPad_Backlight_menu:
.mcc MCC_SET_CURLIST

My_KeyPad_Backlight_menu_sub:
.mcc MCC_INIT_RESTORE
.mcc MCC_RELEASE_LIST
.mcc MCC_SET_LIST00x00140x00800x005A
.mcc MCC_TASK0x100x64
.mcc MCC_DISP_LIST

.mcc MCC_IF 0x9 0x1 0xE 	0 My_Backlight_menu_select			@  	
.mcc MCC_IF 0x9 0x1 0x8 	0 My_Backlight_menu_select	    	@ 
.mcc MCC_IF 0x9 0x1 0x12 	0 My_Backlight_menu_select 			@ I ( X-tend Navigator)

.mcc MCC_IF0x90x20x1	0My_Backlight_menu_select			@ 1
.mcc MCC_IF0x90x20x2	0My_Backlight_menu_select			@ 2
.mcc MCC_IF0x90x20x3	0My_Backlight_menu_select			@ 3

.mcc MCC_IF 0x9 0x1 0x1 	0 My_KeyPad_Backlight_menu_ret		@  
.mcc MCC_IF 0x9 0x1 0xF 	0 My_KeyPad_Backlight_menu_ret		@  
.mcc MCC_IF 0x9 0x1 0x2 	0 My_KeyPad_Backlight_menu_ret		@ 
.mcc MCC_IF 0x9 0x1 0x9 	0 rel_xit							@  

@    (DspList + #32)
My_Backlight_menu_select:
.mcc MCC_IF 0x12 0x15 0 0 My_KeyPad_Backlight_Mode_Menu			@
.mcc MCC_IF 0x12 0x15 1 0 My_Keypad_After_Set_Time				@
.mcc MCC_IF 0x12 0x15 2 0 My_Keypad_Up_To_Set_Time				@


My_KeyPad_Backlight_menu_ret:
.mcc MCC_RELEASE_LIST
.mcc MCC_RETMENU 0x1

rel_xit:
.mcc MCC_RELEASE_LIST
.mcc MCC_EXIT

My_KeyPad_Backlight_Mode_Menu:
.mcc MCC_TASK0x100x64 0x3

.mcc MCC_INIT_RESTORE
.mcc MCC_RELEASE_LIST
.mcc MCC_SET_LIST00x00140x00800x005A
.mcc MCC_TASK0x100x64 0x1
.mcc MCC_DISP_LIST

.mcc MCC_IF 0x9 0x1 0xE 	0 My_config_mode_select			@  	
.mcc MCC_IF 0x9 0x1 0x8 	0 My_config_mode_select	    	@ 
.mcc MCC_IF 0x9 0x1 0x12 	0 My_config_mode_select 		@ I ( X-tend Navigator)

.mcc MCC_IF 0x9 0x1 0x1 	0 My_config_mode_select_ret
.mcc MCC_IF 0x9 0x1 0xF 	0 My_config_mode_select_ret
.mcc MCC_IF 0x9 0x1 0x2 	0 My_config_mode_select_ret
.mcc MCC_IF 0x9 0x1 0x9 	0 rel_xit

My_config_mode_select:
.mcc MCC_TASK0x100x64 0x2									@  
.mcc MCC_CALL 0 0 0 0 mcc_set_report_change_call			@ ""

My_config_mode_select_ret:
.mcc MCC_RELEASE_LIST
.mcc MCC_SET_CURLIST 0										@ 0-  ( 0)
.mcc MCC_TRANSF 0 0 0 0 My_KeyPad_Backlight_menu_sub

@     ''
My_Keypad_After_Set_Time:
.mcc MCC_IF 0x10 0x64 0 0 My_Keypad_After_Set_Time_Message_ret
.mcc MCC_INIT_RESTORE
.mcc MCC_RELEASE_LIST
.mcc MCC_EBUF 1
.mcc MCC_TASK 0x100x64 4									@  
.mcc MCC_TASK 0x12 0x3E 6									@ ""
.mcc MCC_EDIT 0x12 0x13 0x30F 0x2647						@  							
.mcc MCC_IF 0x9 0x1 0xF 	0 My_Keypad_After_Set_Time_ret	@  
.mcc MCC_IF 0x9 0x1 0x1 	0 My_Keypad_After_Set_Time_ret	@  
.mcc MCC_ELSEIF 0x9 0x1 0x9 0 rel_xit						@  

.mcc MCC_IF 0x12 0x18 0x1 0x1 My_Keypad_After_Set_Time_12

.mcc MCC_TASK 0x100x64 5									@  
.mcc MCC_CALL 0 0 0 0 mcc_set_report_change_call			@ ""

My_Keypad_After_Set_Time_ret:
.mcc MCC_RELEASE_LIST
My_Keypad_After_Set_Time_ret_sub:
.mcc MCC_SET_CURLIST 1										@ 1-  ( 0)
.mcc MCC_TRANSF 0 0 0 0 My_KeyPad_Backlight_menu_sub

My_Keypad_After_Set_Time_Message_ret:
.mcc MCC_REPORT 0x1 0x2 0x16 0x2649							@ "   . "
.mcc MCC_TRANSF 0 0 0 0 My_Keypad_After_Set_Time_ret_sub

My_Keypad_After_Set_Time_12:
.mcc MCC_SET_CURLIST 0
.mcc MCC_INIT_RESTORE
.mcc MCC_SKDISPLAY 0x12 0 0x40 0x43							@-
.mcc MCC_DISP_TITLE 0x12 0x2647								@ ""
.mcc MCC_SET_LIST 0 0x14 0x80 0x5A
.mcc MCC_CREATE_LIST 0x1 0x2								@ 
.mcc MCC_ADD_LIST 0 0x2 0x12 0x371							@ AM
.mcc MCC_ADD_LIST 0x1 0x2 0x12 0x372						@ PM
.mcc MCC_DISP_LIST

.mcc MCC_IF 0x9 0x1 0xF 0 My_Keypad_After_Set_Time			@  
.mcc MCC_ELSEIF 0x9 0x1 0x2 0 My_Keypad_After_Set_Time		@ 
.mcc MCC_ELSEIF 0x9 0x1 0x1 0 My_Keypad_After_Set_Time		@  
.mcc MCC_ELSEIF 0x9 0x1 0x9 0 rel_xit						@  
.mcc MCC_TASK 0x12 0x56

.mcc MCC_RELEASE_LIST
.mcc MCC_RETURN	 

@     ''
My_Keypad_Up_To_Set_Time:
.mcc MCC_IF 0x10 0x64 0 0 My_Keypad_Up_To_Set_Time_Message_ret
.mcc MCC_INIT_RESTORE
.mcc MCC_RELEASE_LIST
.mcc MCC_EBUF 1
.mcc MCC_TASK 0x100x64 4 1									@  
.mcc MCC_TASK 0x12 0x3E 7									@ ""
.mcc MCC_EDIT 0x12 0x13 0x30F 0x2648						@  							
.mcc MCC_IF 0x9 0x1 0xF 	0 My_Keypad_Up_To_Set_Time_ret	@  
.mcc MCC_IF 0x9 0x1 0x1 	0 My_Keypad_Up_To_Set_Time_ret	@  
.mcc MCC_ELSEIF 0x9 0x1 0x9 0 rel_xit						@  

.mcc MCC_IF 0x12 0x18 0x1 0x1 My_Keypad_Up_To_Set_Time_12

.mcc MCC_TASK 0x100x64 5 1									@  
.mcc MCC_CALL 0 0 0 0 mcc_set_report_change_call			@ ""

My_Keypad_Up_To_Set_Time_ret:
.mcc MCC_RELEASE_LIST
My_Keypad_Up_To_Set_Time_ret_sub:
.mcc MCC_SET_CURLIST 2										@ 2-  ( 0)
.mcc MCC_TRANSF 0 0 0 0 My_KeyPad_Backlight_menu_sub

My_Keypad_Up_To_Set_Time_Message_ret:
.mcc MCC_REPORT 0x1 0x2 0x16 0x2649							@ "   . "
.mcc MCC_TRANSF 0 0 0 0 My_Keypad_Up_To_Set_Time_ret_sub

My_Keypad_Up_To_Set_Time_12:
.mcc MCC_SET_CURLIST
.mcc MCC_INIT_RESTORE
.mcc MCC_SKDISPLAY 0x12 0 0x40 0x43							@-
.mcc MCC_DISP_TITLE 0x12 0x2648								@ ""
.mcc MCC_RELEASE_LIST
.mcc MCC_SET_LIST 0 0x14 0x80 0x5A
.mcc MCC_CREATE_LIST 0x1 0x2								@ 
.mcc MCC_ADD_LIST 0 0x2 0x12 0x371							@ AM
.mcc MCC_ADD_LIST 0x1 0x2 0x12 0x372						@ PM
.mcc MCC_DISP_LIST

.mcc MCC_IF 0x9 0x1 0xF 0 My_Keypad_Up_To_Set_Time			@  
.mcc MCC_ELSEIF 0x9 0x1 0x2 0 My_Keypad_Up_To_Set_Time		@ 
.mcc MCC_ELSEIF 0x9 0x1 0x1 0 My_Keypad_Up_To_Set_Time		@  
.mcc MCC_ELSEIF 0x9 0x1 0x9 0 rel_xit						@  
.mcc MCC_TASK 0x12 0x56

.mcc MCC_RELEASE_LIST
.mcc MCC_RETURN	 

@ ""
mcc_set_report_change_call:
.mcc MCC_INIT_RESTORE
.mcc MCC_REPORT 0xE 0x2 0xA 0x4B3
.mcc MCC_RETURN

.string "</Mcc scripts>"
.string "</Keypad Backlight By NeO_2kX>"